package worb.protocols.iiop.xml;

import org.w3c.dom.*;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Stack;
import java.io.PrintStream;
import java.net.*;


/**
*
* @date   September 26, 1998 ( Last Updated September 26, 1998 )
* @author H. Timucin Ozdemir
*
*/
public class 
ImRDocument implements XMLDebugFlags, ImRConstants
{

   /** ImplementationRepository Entries */
   Hashtable imaps;

   /** Version */
   String version;

   /** Federation Name */
   String FedName;

   /** Routing Spaces */
   //Vector spaces;
   Hashtable spaces;

   /** Object Classes */
   //Vector objClasses;
   Hashtable objClasses;

   /** Interaction Classes */
   //Vector interClasses;
   Hashtable interClasses;

   /** isExtracted? */
   boolean isExtracted = true;

   /** org.w3c.dom.Document */
   Document dom;

   /**
   */
   public ImRDocument(Document _dom)
   {
      interClasses = new Hashtable();
             imaps = new Hashtable();
        objClasses = new Hashtable();
            spaces = new Hashtable();
               dom = _dom;
      isExtracted  = true;

   }// end of CONSTRUCTOR

   /**
   */
   public ImRDocument()
   {
      isExtracted  = false;
             imaps = new Hashtable();
      interClasses = new Hashtable();
        objClasses = new Hashtable();
            spaces = new Hashtable();

   }// end of CONSTRUCTOR

   /**
   */
   public Enumeration 
   getRegisteredImplementations() 
   { 
      if(isExtracted) extractFromDocument();

      if(DEBUG8) print(System.out);

      return imaps.elements(); 

   }// end of getRegisteredImplementations()

   /**
   * Adds implementation item object.
   */
   void 
   addImplementationItem( ImplementationItem _item ) 
   { 
      imaps.put( _item.getName(), _item ); 

   }// end of addImplementationItem()

   /**
   */
   public void 
   extractFromDocument() 
   { 
      if(DEBUG) System.out.println(" in extractFromDocument() ");
      isExtracted = false;
      if(dom!=null)
      {
         Element fedRoot = dom.getDocumentElement();
         if( fedRoot.getTagName().equals(ImpListLabel) ) extractItems(fedRoot);

      } else System.out.println(" Document is NULL1");

      if(DEBUG) System.out.println(" out of extractFromDocument() ");

   }// end of extractFromDocument()

   /**
   */
   final void 
   extractItems(Element fedRoot)
   {

     if(DEBUG) System.out.println(" in extractItems() ");
     NodeList fedNames = ((Node)fedRoot).getChildNodes();
     NodeList fedNames1 ;
     Node     current=null; 
     Node     current2=null; 
     int      i=0;

     if( fedNames!=null && fedNames.getLength()>0) 
     {
        while( i<fedNames.getLength() )
        {
           current = fedNames.item(i++);
           if( current!=null && current.getNodeType()==org.w3c.dom.Node.ELEMENT_NODE &&
               ((Element)current).getTagName().equals(ImplItemLabel)) 
               extractOneItem((Element)current);

        }// end of while

     }// end of if 

     if(DEBUG) System.out.println(" out of extractItems() ");

   }// end of extractItems()

   /**
   */
   final void 
   extractOneItem(Element fedRoot)
   {

     if(DEBUG) System.out.println(" in extractOneItem() ");
     NodeList fedNames = ((Node)fedRoot).getChildNodes();
     NodeList fedNames1 ;
     Node     current=null; 
     Node     current2=null; 
     int      i=0;

     String   imp_name  = null;
     String   imp_cname = null;
     Vector   paths = new Vector();

     if( fedNames!=null && fedNames.getLength()>0 ) 
     {
        boolean namefound  = false; 
        boolean cnamefound = false; 
        boolean pathFound  = false; 

        while( i<fedNames.getLength() )
        {
          current = fedNames.item(i++);
          if( current!=null && current.getNodeType()==org.w3c.dom.Node.ELEMENT_NODE )
          {
              if( ((Element)current).getTagName().equals(nameLabel) ) 
              {

                fedNames1 = current.getChildNodes() ;
                if(fedNames1!=null && fedNames1.getLength()>0)
                {

                  current2 = fedNames1.item(0);

                  if( current2!=null && 
                      current2.getNodeType()==org.w3c.dom.Node.TEXT_NODE )
                  { 
                      namefound = true; 
                      imp_name = new String(((CharacterData)current2).getData()); 

                  }// end of if

                }// end of if

              }
              else

              if( ((Element)current).getTagName().equals(cnameLabel) ) 
              {

                fedNames1 = current.getChildNodes() ;
                if(fedNames1!=null && fedNames1.getLength()>0)
                {

                  current2 = fedNames1.item(0);

                  if( current2!=null && 
                      current2.getNodeType()==org.w3c.dom.Node.TEXT_NODE )
                  { 
                      cnamefound = true; 
                      imp_cname = new String(((org.w3c.dom.CharacterData)current2).getData()); 

                  }// end of if

                }// end of if

              }
              else

              if( ((Element)current).getTagName().equals(pathListLabel) ) 
                  extractPathList((org.w3c.dom.Element)current,paths);

          }// end of if

        }// end of while

        if( namefound && cnamefound )
        {
           ImplementationItem impItem = new ImplementationItem( imp_name, imp_cname );
           Enumeration e = paths.elements();
           while( e.hasMoreElements() ) impItem.addPath((String)e.nextElement());
           addImplementationItem(impItem);

        }// end  of if

     }// end of if 

     if(DEBUG) System.out.println(" out of extractOneItem() ");

   }// end of extractOneItem()

   /**
   */
   final void 
   extractPathList(Element fedRoot, Vector paths)
   {

     if(DEBUG) System.out.println(" in extractOneItem() ");
     NodeList fedNames = ((Node)fedRoot).getChildNodes();
     NodeList fedNames1 ;
     Node     current=null; 
     Node     current2=null; 
     int      i=0;

     if( fedNames!=null && fedNames.getLength()>0 ) 
     {
        while( i<fedNames.getLength() )
        {
          current = fedNames.item(i++);
          if( current!=null && current.getNodeType()==org.w3c.dom.Node.ELEMENT_NODE )
          {
              if( ((Element)current).getTagName().equals(pathLabel) ) 
              {

                fedNames1 = current.getChildNodes() ;
                if(fedNames1!=null && fedNames1.getLength()>0)
                {

                  current2 = fedNames1.item(0);

                  if( current2!=null && current2.getNodeType()==org.w3c.dom.Node.TEXT_NODE )
                      paths.addElement(((org.w3c.dom.CharacterData)current2).getData());

                }// end of if

              }// end of if

          }// end of if

        }// end of while

     }// end of if 

     if(DEBUG) System.out.println(" out of extractPathList() ");

   }// end of extractPathList()

   /**
   */
   public void 
   print(PrintStream o) 
   { 
      o.println( "<"+ImpListLabel+">");
      Enumeration e = imaps.elements();

      while( e.hasMoreElements() )
      {
         ImplementationItem imItem = (ImplementationItem) e.nextElement();
         if( imItem!=null ) imItem.print(o);

      }// end of while

      o.println( "</"+ImpListLabel+">");

   }// end of print()

   public static String 
   makeAbsoluteURL (String url) throws MalformedURLException
   {
      URL baseURL;
      String currentDirectory = System.getProperty("user.dir");
      String fileSep = System.getProperty("file.separator");
      String file = currentDirectory.replace(fileSep.charAt(0), '/') + '/';
      if (file.charAt(0) != '/') { file = "/" + file; }
      baseURL = new URL("file", null, file);
      return new URL(baseURL,url).toString();

   }// end of makeAbsoluteURL()


}// end of ImRDocument
